
; ATmega88

; Fuse-Bits fr Mega88:
; externer Takt

; 30.05.2009 M'Soft Berlin

; 29.06.2009 FW 0.8
; etwas aufgerumt...
; einstellbare Bufferlnge eingebaut

; 14.07.2009 FW 1.1
; 32k Ram eingebaut

; 22.07.2009 FW 1.2
; Kommandofolge umgebaut, Hardware-Test Eingang H eingebaut

.equ	FW_VER		= '1'
.equ	FW_REV		= '2'

.equ	HW_VER		= '1'
.equ	HW_REV		= '1'

.include "m88def.inc"

.include "Definitionen.inc"

;****************************** Verktor-Liste ****************************

.CSEG
		rjmp    Reset

.ORG	URXCaddr
		rjmp	irq_rx						; fr Break-Funktion

;****************************** Programm-Beginn **********************

.ORG	INT_VECTORS_SIZE
 
;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

; Hardware initialisieren

Reset:
	  ldi     TEMP_0,low(RAMEND)          ; Stack an das interne Ram-Ende
	  out     SPL,TEMP_0
    ldi     TEMP_0,high(RAMEND)
    out     SPH,TEMP_0

; Port B *************************************************************

		ldi		TEMP_0,~((1<<C_CLOCK) | (1<<SHIFT_CLOCK))								; Ram-Clock auf L					; 
		out		PORTB,TEMP_0
		ldi		TEMP_0,(1<<C_CLOCK)	| (1<<SHIFT_CLOCK) 	| (1<<SHIFT_DATA) | (1<<TRIG_ENABLE)
		out		DDRB,TEMP_0

; Port C *************************************************************

		ldi		TEMP_0,~((1<<MUX_A) | (1<<MUX_B) | (1<<C_SAMPLE))	; MUX auf 00
		out		PORTC,TEMP_0
		ldi		TEMP_0,(1<<C_SAMPLE) | (1<<C_BUFFER) | (1<<MUX_A) | (1<<MUX_B) | (1<<SHIFT_CLOCK) | (1<<SHIFT_DATA)		; alles Ausgang
		out		DDRC,TEMP_0
	
; Port D *************************************************************
		
		ser		TEMP_0												; PullUp ein
		out		PORTD,TEMP_0
		clr		TEMP_0												; alles Eingang
		out		DDRD,TEMP_0			

; UART ***************************************************************

		ldi   TEMP_0,high(UART_BAUD_SELECT)
    sts   UBRR0H,TEMP_0
    ldi   TEMP_0,low(UART_BAUD_SELECT)
    sts   UBRR0L,TEMP_0

		ldi   TEMP_0,(1<<U2X0)
		sts	  UCSR0A,TEMP_0

    ldi   TEMP_0,(1<<TXEN0) | (1<<RXEN0) | (1<<RXCIE0)
    sts   UCSR0B,TEMP_0

    ldi   TEMP_0,(1<<UCSZ01) | (1<<UCSZ00)
    sts   UCSR0C,TEMP_0
 
;*********************************************************************				 

; Software initialisieren

		clr		NULL
    clr   FLAGS

		ldi		TEMP_0,DATEN_1_MASKE		; Maske untere Bits
		mov		DATEN_1_M,TEMP_0
		com		TEMP_0									; negierte Maske untere Bits
		mov		DATEN_1_M_N,TEMP_0

		ldi		TEMP_0,DATEN_2_MASKE		; Maske untere Bits
		mov		DATEN_2_M,TEMP_0
		com		TEMP_0									; negierte Maske untere Bits
		mov		DATEN_2_M_N,TEMP_0

    load_p Y,BUF_LEN_MAX
    sts		BUF_LEN_L,YL
		sts		BUF_LEN_H,YH

;*********************************************************************
;  Main-Loop
;*********************************************************************

main:					
		rcall	uart_receive_byte			; 7 Mode
		cpi		TEMP_0,CMD_RESTART		; Command-Byte?
		breq	main  								; ja

		mov		MODE,TEMP_0

		rcall	uart_receive_byte			; 1 Triggerbyte
		mov		TRIG_BYTE,TEMP_0

		rcall	uart_receive_byte			; 2 Triggermaske
		mov		TRIG_MASK,TEMP_0

		rcall	uart_receive_byte			; 3 Timerintervall
		cpi		TEMP_0,CMD_RESTART		; Reset-Byte?
		breq	main									; ja

		mov		TIMER_WERT,TEMP_0
			
		rcall	uart_receive_byte			; 5 Pretrigger
		cpi		TEMP_0,CMD_RESTART		; Reset-Byte?
		breq	main									; ja

		mov		PRE_TRIGGER,TEMP_0

		rcall	uart_receive_byte			; 6 zustzliches 1. LS164
    mov   RESERVE_1,TEMP_0

		rcall	uart_receive_byte			; 7 zustzliches 2. LS164
    mov   RESERVE_2,TEMP_0

		cpi		MODE,MODE_MAX					; ungltiger Mode
		brsh	main

		load_p	Z,(2*tab_funktion)
		lsl		MODE
		add		ZL,MODE
		adc		ZH,NULL
		lpm		YL,Z+									; Funtionsadresse holen
		lpm		YH,Z
		mov		ZL,YL									; und nach Z fr ICALL
		mov		ZH,YH

		icall

		cpi   MODE,10
    brlo  main

    rcall	send_daten

		rjmp	main

;*********************************************************************

irq_rx:
		in		SREG_SAVE,SREG

		lds		YL,UDR0								; Byte abholen

		ldi		YL,1									; Restzhler auf Minimum
		ldi		YH,0

		sbr		SREG_SAVE,(1<<SREG_T)
    com   FLAGS

		out		SREG,SREG_SAVE

		reti

;*********************************************************************

.include "Subroutinen.inc"
.include "Testroutinen.inc"
.include "Tabellen.inc"

