
;*********************************************************************
; Sub: Hardwaretest
; Parameter:    -
; Return:       -
; Scratch-Reg:  Y, Z
;*********************************************************************

test_input_h:
    sbi   CTRL_PORT,C_SAMPLE        ; Ram auf sampeln
    cbi   CTRL_PORT,C_BUFFER        ; Buffer aktiv

    nop
    nop

		in		TEMP_0,DATEN_1_IN					; Byte holen		
		and		TEMP_0,DATEN_1_M
		in		TEMP_1,DATEN_2_IN		
		and		TEMP_1,DATEN_2_M
		or		TEMP_1,TEMP_0	

    ldi   TEMP_0,1                  ; Testnummer
    rcall uart_send_byte

    ldi   TEMP_0,0b11111111
    rcall uart_send_byte

    mov   TEMP_0,TEMP_1
    rcall uart_send_byte

    sbi   CTRL_PORT,C_BUFFER        ; Buffer inaktiv
    cbi   CTRL_PORT,C_SAMPLE        ; Ram auf Lesen

    ret

;*********************************************************************
; Sub: Hardwaretest
; Parameter:    -
; Return:       -
; Scratch-Reg:  Y, Z
;*********************************************************************

test_input_l:
    sbi   CTRL_PORT,C_SAMPLE        ; Ram auf Ssmpeln
    cbi   CTRL_PORT,C_BUFFER        ; Buffer aktiv

    nop
    nop

		in		TEMP_0,DATEN_1_IN					; Byte holen		
		and		TEMP_0,DATEN_1_M
		in		TEMP_1,DATEN_2_IN		
		and		TEMP_1,DATEN_2_M
		or		TEMP_1,TEMP_0	

    cpi   TEMP_1,0b00000000
    breq  test_input_l_weiter

    ldi   TEMP_0,2                  ; Testnummer
    rcall uart_send_byte

    ldi   TEMP_0,0b00000000
    rcall uart_send_byte

    mov   TEMP_0,TEMP_1
    rcall uart_send_byte

    rjmp  Test_input_l_ende

test_input_l_weiter:
    sbi   CTRL_PORT,C_BUFFER        ; Eingangsbuffer in TriState

    in    TEMP_0,DATEN_1_PORT
    or    TEMP_0,DATEN_1_M
    out   DATEN_1_PORT,TEMP_0       ; PullUp ein

    in    TEMP_0,DATEN_2_PORT
    or    TEMP_0,DATEN_2_M
    out   DATEN_2_PORT,TEMP_0       ; PullUp ein

    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop

    in		TEMP_0,DATEN_1_IN					; Byte holen, sollten jetzt alle H sein		
		and		TEMP_0,DATEN_1_M
		in		TEMP_1,DATEN_2_IN		
		and		TEMP_1,DATEN_2_M
		or		TEMP_1,TEMP_0	

    ldi   TEMP_0,2                  ; Testnummer
    rcall uart_send_byte

    ldi   TEMP_0,0b11111111
    rcall uart_send_byte

    mov   TEMP_0,TEMP_1
    rcall uart_send_byte

test_input_l_ende:

    sbi   CTRL_PORT,C_BUFFER     ; Buffer inaktiv
    cbi   CTRL_PORT,C_SAMPLE     ; Ram auf Lesen

    ret
